﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Threading
Imports System.IO
Imports System.Text.RegularExpressions

Module Module1

    Public Function IsIP(ByVal ip As String) As Boolean
        Return Regex.IsMatch(ip, "^((2[0-4]\d|25[0-5]|[01]?\d\d?)\.){3}(2[0-4]\d|25[0-5]|[01]?\d\d?)$")
    End Function

    Sub Main()
        Dim IP As String = ""
        Dim ret As Boolean = False
        Dim quitIP As Boolean = False
        Dim quit As Boolean = False
        Dim hHS As IntPtr
        Dim gVal As UInt16 = 0
        Dim oVal As Int16 = 0
        Dim gVarr As UInt16() = New UInt16(7) {}
        Dim oVarr As Int16() = New Int16(7) {}
        Dim ChCnt As Short = 8
        Dim Gain As Short = 0
        Dim ulleng As UInteger = 0
        Dim triggerStatus As UInteger = 0
        Dim TrigMode As Short = 0
        Dim targetCnt As UInt32 = 8000
        Dim sampleRate As Integer = 1000
        Dim DataTransMethod As Short = 0
        Dim AutoRun As Short = 0
        Dim path As String = Directory.GetCurrentDirectory()

        While quitIP = False
            Console.WriteLine("Please Enter IP!!")
            IP = Console.ReadLine()
            ret = IsIP(IP)

            If ret = False Then
                Console.WriteLine("Please enter the correct IP")
            Else
                quitIP = True
                Thread.Sleep(100)
            End If
        End While

        hHS = HSDAQNet.Sys.HS_Device_Create(IP)
        Console.WriteLine("HSDAQ SDK Ver= " & HSDAQNet.Sys.GetSDKVersion().ToString())
        Console.WriteLine("ET7H16 Firmware Ver= " & HSDAQNet.Sys.GetFirmwareVersion(hHS).ToString())
        ret = HSDAQNet.HSIO.HS_SetAIScanParam(hHS, ChCnt, Gain, TrigMode, sampleRate, targetCnt, DataTransMethod, AutoRun)
        HSDAQNet.HSIO.HS_GetAIScanParam(hHS, ChCnt, Gain, TrigMode, sampleRate, targetCnt, DataTransMethod, AutoRun)
        Console.WriteLine("Ch=" & ChCnt & ",Gain=" & Gain & ",TrigMode=" & TrigMode & ",sampleRate=" & sampleRate & ",targetCnt=" & targetCnt)

        For ch As Integer = 0 To 8 - 1
            HSDAQNet.Config.HS_ReadGainOffset(hHS, ch, Gain, gVal, oVal)
            gVarr(ch) = gVal
            oVarr(ch) = oVal
            Console.WriteLine("[ch" & ch & "]Gain = " & gVal & " , Offset = " & oVal)
        Next

        Console.WriteLine("Press any key to continue.....")

        If Not ret Then
            Console.WriteLine("Error code1 0x" & HSDAQNet.ErrHandling.GetLastError().ToString("x8"))
        Else
            ret = HSDAQNet.DATALOG.HS_StartLogger(hHS, path, 2, 0)

            If ret = False Then
                Console.WriteLine("Error code2 0x" & HSDAQNet.ErrHandling.GetLastError().ToString("x8"))
            End If

            While quit = False
                ret = HSDAQNet.HSIO.HS_GetTotalSamplingStatus(hHS, ulleng, triggerStatus)

                If ret = False Then
                    Console.WriteLine("Error code3 0x" & HSDAQNet.ErrHandling.GetLastError().ToString("x8"))
                Else
                    If ((ulleng >= targetCnt) And (triggerStatus >> 7) = 1) Then
                        Console.WriteLine(vbCrLf & "AP total read = " & ulleng.ToString() & vbCrLf)

                        Thread.Sleep(10)
                        Exit While
                    End If
                End If
                If Console.ReadKey(True).Key = ConsoleKey.Q Then
                    Exit While
                End If
            End While

            HSDAQNet.DATALOG.HS_StopLogger(hHS)
            Thread.Sleep(10)
            HSDAQNet.Sys.HS_Device_Release(hHS)
        End If

        Dim gchCnt As Short = 0
        Dim guseGain As Short = 0
        Dim gextriggMode As Short = 0
        Dim gsampleRate As Integer = 0
        Dim gDataTransMethod As Short = 0
        Dim gSyncMode As Short = 0
        Console.WriteLine("Waiting for search .....")
        Dim ind As Integer = HSDAQNet.DATALOG.HS_GetAllLogFiles(path, 0)

        If ind > 0 Then

            For i As Integer = 0 To ind - 1
                Dim hlf As IntPtr = HSDAQNet.DATALOG.HS_LogFile_Open_byIndex(i, path)
                Console.WriteLine(vbCrLf & i & " ==> " & path)
                HSDAQNet.DATALOG.HS_GetLogFile_AIScanConfigInfo(hlf, gchCnt, guseGain, gextriggMode, gsampleRate, gDataTransMethod, gSyncMode)
                Console.WriteLine("Ch= " & gchCnt & "," & "Gain= " & guseGain & "," & "TriggMode= " & gextriggMode & "," & "SampleRate= " & gsampleRate & "," & "DataTransMethod= " & gDataTransMethod)
                Dim gainVal As UShort = 0
                Dim offsetVal As Short = 0

                For c As Integer = 0 To gchCnt - 1
                    HSDAQNet.DATALOG.HS_GetLogFile_GainOffset(hlf, c, guseGain, gainVal, offsetVal)
                    Console.WriteLine(c & ",Gain= " & gainVal & ",Offset= " & offsetVal)
                Next

                Dim filesize As UInt32 = 0
                Dim filetype As Integer = 0
                Dim fileversion As Integer = 0
                Dim samplecount As UInt32 = 0
                Dim DataTime As String = ""
                Dim StartTime As String = ""
                Dim fileName As String = ""

                HSDAQNet.DATALOG.HS_GetLogFileInfo(hlf, fileName, filesize, filetype, fileversion)
                Console.WriteLine("Filesize= " & filesize & ",Filetype= " & filetype)
                Dim fValue As Integer() = New Integer(targetCnt - 1) {}
                HSDAQNet.DATALOG.HS_GetLogFile_AIDataHex(hlf, 0, targetCnt, fValue)
                Dim a As Integer = 0
                HSDAQNet.DATALOG.HS_GetLogFile_AIScanSampleInfo(hlf, samplecount, DataTime, StartTime)
                Console.WriteLine("Samplecount= " & samplecount & ",DataTime= " & DataTime & ",StartTime= " & StartTime)

                While a < 40
                    Console.WriteLine(fValue(a).ToString("00000") & "," & fValue(a + 1).ToString("00000") & "," & fValue(a + 2).ToString("00000") & "," & fValue(a + 3).ToString("00000") & "," & fValue(a + 4).ToString("00000") & "," & fValue(a + 5).ToString("00000") & "," & fValue(a + 6).ToString("00000") & "," & fValue(a + 7).ToString("00000"))
                    a = a + 8
                End While
                HSDAQNet.DATALOG.HS_LogFile_Close(hlf)
            Next
        Else
            Console.WriteLine("No File!!")
        End If

        Console.WriteLine("Press 'Q' to quit program")


        While Console.ReadKey(True).Key <> ConsoleKey.Q
        End While
    End Sub

End Module
