﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Threading
Imports System.IO
Imports System.Text.RegularExpressions

Module Module1

    Public Function IsIP(ByVal ip As String) As Boolean
        Return Regex.IsMatch(ip, "^((2[0-4]\d|25[0-5]|[01]?\d\d?)\.){3}(2[0-4]\d|25[0-5]|[01]?\d\d?)$")
    End Function

    Sub Main()
        Dim IP As String = ""
        Dim ret As Boolean = False
        Dim quitIP As Boolean = False
        Dim quit As Boolean = False
        Dim triggerEvent As Boolean = False
        Dim hHS As IntPtr
        Dim hcom As IntPtr
        Dim gVal As UInt16 = 0
        Dim oVal As Int16 = 0
        Dim gVarr As UInt16() = New UInt16(7) {}
        Dim oVarr As Int16() = New Int16(7) {}
        Dim ChCnt As Short = 8
        Dim I7Kcom As String = "COM13,9600,N,8,1"
        Dim Gain As Short = 0
        Dim ulleng As UInteger = 0
        Dim BufferStatus As UShort = 0
        Dim readsize As UInt32 = 0
        Dim extCLKCnt As Short = 20000
        Dim TrigMode As Short = 1
        Dim targetCnt As UInt32 = 20000
        Dim sampleRate As Integer = 30000
        Dim DataTransMethod As Short = 0
        Dim AutoRun As Short = 0

        While quitIP = False
            Console.WriteLine("Please Enter IP!!")
            IP = Console.ReadLine()
            ret = IsIP(IP)

            If ret = False Then
                Console.WriteLine("Please enter the correct IP")
            Else
                quitIP = True
                Thread.Sleep(100)
            End If
        End While

        hHS = HSDAQNet.Sys.HS_Device_Create(IP)
        hcom = PACNET.UART.Open(I7Kcom)
        Console.WriteLine("HSDAQ SDK Ver= " & HSDAQNet.Sys.GetSDKVersion().ToString())
        Console.WriteLine("ET7H16 Firmware Ver= " & HSDAQNet.Sys.GetFirmwareVersion(hHS).ToString())
        Directory.CreateDirectory("C:\test")
        Dim fileStream As FileStream = New FileStream("C:\test\test.txt", FileMode.OpenOrCreate)
        fileStream.Close()
        ret = HSDAQNet.HSIO.HS_SetAIScanParam(hHS, ChCnt, Gain, TrigMode, sampleRate, targetCnt, DataTransMethod, AutoRun)
        HSDAQNet.HSIO.HS_GetAIScanParam(hHS, ChCnt, Gain, TrigMode, sampleRate, targetCnt, DataTransMethod, AutoRun)
        Console.WriteLine("Ch=" & ChCnt & ",Gain=" & Gain & ",TrigMode=" & TrigMode & ",sampleRate=" & sampleRate & ",targetCnt=" & targetCnt)

        For ch As Integer = 0 To 8 - 1
            HSDAQNet.Config.HS_ReadGainOffset(hHS, ch, Gain, gVal, oVal)
            gVarr(ch) = gVal
            oVarr(ch) = oVal
        Next

        If Not ret Then
            Console.WriteLine("Error code1 0x" & HSDAQNet.ErrHandling.GetLastError().ToString("x8"))
        Else
            ret = HSDAQNet.HSIO.HS_StartAIScan(hHS)

            If ret = False Then
                Console.WriteLine("Error code2 0x" & HSDAQNet.ErrHandling.GetLastError().ToString("x8"))
            End If

            Console.WriteLine("Press any key to trigger an external signal....")

            If True Then

                While quit = False
                    ret = HSDAQNet.HSIO.HS_GetAIBufferStatus(hHS, BufferStatus, ulleng)


                    If ret = False Then
                        Console.WriteLine("Error code3 0x" & HSDAQNet.ErrHandling.GetLastError().ToString("x8"))
                    Else

                        If (BufferStatus > 2 And (BufferStatus And &H8)) Then
                            Console.WriteLine("BufferStatus Error<" & BufferStatus & ">," & ulleng)
                            Exit While
                        End If



                        If (ulleng >= targetCnt And BufferStatus > 2) Then
                            quit = True
                        End If
                    End If

                    If Console.KeyAvailable Then
                        Thread.Sleep(100)

                        If hcom = CType((-1), IntPtr) Then
                            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
                            Console.WriteLine((CType(ec, PACNET.ErrCode)).ToString() & "I-7088 COM Port open error" & vbCrLf & "Error Code: 0x" & ec.ToString("X"))
                        End If

                        ret = PACNET.PWM.SetPWMFrequency(hcom, PACNET.PAC_IO.PAC_REMOTE_IO(1), 0, 10000)

                        If Not ret Then
                            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
                            Console.WriteLine((CType(ec, PACNET.ErrCode)).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
                        Else
                            PACNET.PWM.SetPWMPulseCount(hcom, PACNET.PAC_IO.PAC_REMOTE_IO(1), 0, extCLKCnt)
                            PACNET.PWM.SetPWMStart(hcom, PACNET.PAC_IO.PAC_REMOTE_IO(1), 1)
                            Console.WriteLine("The external CLK signal is triggered")
                        End If

                        Thread.Sleep(1000)
                        PACNET.PWM.SetPWMStart(hcom, PACNET.PAC_IO.PAC_REMOTE_IO(1), 0)
                    End If

                    If triggerEvent Then
                        Console.WriteLine("Press 'Q' to quit program")

                        While triggerEvent = True

                            If Console.ReadKey().Key = ConsoleKey.Q Then
                                triggerEvent = False
                                quit = True
                                Exit While
                            Else
                                Thread.Sleep(10)
                            End If
                        End While
                    End If

                    Thread.Sleep(200)
                End While
                Dim FdataBuffer As Single() = New Single(ulleng * 8 * 2 - 1) {}
                readsize = HSDAQNet.HSIO.HS_GetAIBuffer(hHS, FdataBuffer, ulleng)
                HSDAQNet.HSIO.HS_StopAIScan(hHS)
                HSDAQNet.Sys.HS_Device_Release(hHS)
                PACNET.UART.Close(hcom)
                Console.WriteLine(vbCrLf & "AP total read = " & readsize & vbCrLf)
                Console.WriteLine("Press 'Q' to quit program")
                While Console.ReadKey(True).Key <> ConsoleKey.Q
                End While
            End If
        End If
    End Sub

End Module
