﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Threading
Imports System.IO
Imports System.Text.RegularExpressions

Module Module1

    Public Function IsIP(ByVal ip As String) As Boolean
        Return Regex.IsMatch(ip, "^((2[0-4]\d|25[0-5]|[01]?\d\d?)\.){3}(2[0-4]\d|25[0-5]|[01]?\d\d?)$")
    End Function

    Sub Main()
        Dim IP As String = ""
        Dim ret As Boolean = False
        Dim quitIP As Boolean = False
        Dim quit As Boolean = False
        Dim hHS As IntPtr
        Dim ChCnt As Short = 4
        Dim totalRecv As UInt32 = 0
        Dim Gain As Short = 0
        Dim ulleng As UInteger = 0
        Dim BufferStatus As UShort = 0
        Dim readsize As UInt32 = 0
        Dim TrigMode As Short = 0
        Dim targetCnt As UInt32 = 10000
        Dim sampleRate As Integer = 32000
        Dim DataTransMethod As Short = 0
        Dim AutoRun As Short = 0

        While quitIP = False
            Console.WriteLine("Please Enter IP!!")
            IP = Console.ReadLine()
            ret = IsIP(IP)

            If ret = False Then
                Console.WriteLine("Please enter the correct IP")
            Else
                quitIP = True
                Thread.Sleep(100)
            End If
        End While

        hHS = HSDAQNet.Sys.HS_Device_Create(IP)
        Console.WriteLine("Module Name= " & HSDAQNet.Sys.HS_GetModelName(hHS).ToString())
        Console.WriteLine("HSDAQ Ver= " & HSDAQNet.Sys.GetSDKVersion().ToString())
        Console.WriteLine("HSDAQNet Ver= " & HSDAQNet.Sys.GetHSDAQNetVersion().ToString())
        Console.WriteLine("Firmware Ver= " & HSDAQNet.Sys.GetFirmwareVersion(hHS).ToString())
        ret = HSDAQNet.HSIO.HS_SetAIScanParam(hHS, ChCnt, Gain, TrigMode, sampleRate, targetCnt, DataTransMethod, AutoRun)
        HSDAQNet.HSIO.HS_GetAIScanParam(hHS, ChCnt, Gain, TrigMode, sampleRate, targetCnt, DataTransMethod, AutoRun)
        Console.WriteLine("Ch=" & ChCnt & ",Gain=" & Gain & ",TrigMode=" & TrigMode & ",sampleRate=" & sampleRate & ",targetCnt=" & targetCnt)
        'For details, please refer to the API manual
        'AI CH input Range : 1 ~ 4
        'Gain Range        : 0
        'Mode Range        : 0
        'Sample rate       : 
        '  ch=1    : 12.8k/16k/32k/64k/128k Hz
        '  ch=2    : 12.8k/16k/32k/64k Hz
        '  ch=3/4  : 12.8k/16k/32k Hz
        'targetcnt         : 0 (continue mode)
        'filetype          : 0(bin)、1(txt)、3(TDMS float)、4(TDMS Hex)
        'fileinterval      : min

        If Not ret Then
            Console.WriteLine("Error code1 0x" & HSDAQNet.ErrHandling.GetLastError().ToString("x8"))
        Else
            ret = HSDAQNet.HSIO.HS_StartAIScan(hHS)

            If ret = False Then
                Console.WriteLine("Error code2 0x" & HSDAQNet.ErrHandling.GetLastError().ToString("x8"))
            End If

            While quit = False
                ret = HSDAQNet.HSIO.HS_GetAIBufferStatus(hHS, BufferStatus, ulleng)
                Dim fdataBuffer As Single() = New Single(ulleng) {}

                If ret = False Then
                    Console.WriteLine("Error code3 0x" & HSDAQNet.ErrHandling.GetLastError().ToString("x8"))
                Else

                    If (BufferStatus And &H2) = &H2 OrElse (BufferStatus And &H8) = &H8 Then
                        Console.WriteLine("BufferStatus Error<" & BufferStatus & ">," & ulleng)
                        Exit While
                    End If

                    If ulleng = targetCnt Then
                        readsize = HSDAQNet.HSIO.HS_GetAIBuffer(hHS, fdataBuffer, targetCnt)
                        totalRecv = totalRecv + readsize

                        If totalRecv = targetCnt Then
                            quit = True
                        Else
                            Console.WriteLine("readsize = " & readsize.ToString() & vbCrLf & "Get AI buffer error")
                        End If

                        Exit While
                    End If
                End If
            End While

            HSDAQNet.HSIO.HS_StopAIScan(hHS)
            HSDAQNet.Sys.HS_Device_Release(hHS)
            Console.WriteLine(vbCrLf & "AP total read = " & totalRecv & vbCrLf)
        End If

        Console.WriteLine("Press 'Q' to quit program")

        While Console.ReadKey(True).Key <> ConsoleKey.Q
        End While
    End Sub

End Module
