﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Threading
Imports System.IO
Imports System.Text.RegularExpressions

Module Module1

    Public Function IsIP(ByVal ip As String) As Boolean
        Return Regex.IsMatch(ip, "^((2[0-4]\d|25[0-5]|[01]?\d\d?)\.){3}(2[0-4]\d|25[0-5]|[01]?\d\d?)$")
    End Function

    Sub Main()
        Dim IP As String = ""
        Dim ret As Boolean = False
        Dim quitIP As Boolean = False
        Dim quit As Boolean = False
        Dim hHS As IntPtr
        Dim ChCnt As Short = 4
        Dim Gain As Short = 0
        Dim ulleng As UInteger = 0
        Dim triggerStatus As UInteger = 0
        Dim TrigMode As Short = 0
        Dim targetCnt As UInt32 = 0
        Dim sampleRate As Integer = 16000
        Dim DataTransMethod As Short = 0
        Dim AutoRun As Short = 0
        Dim path As String = Directory.GetCurrentDirectory()
        Dim sfiletype As Integer = 1
        Dim sfileinterval As Integer = 1

        While quitIP = False
            Console.WriteLine("Please Enter IP!!")
            IP = Console.ReadLine()
            ret = IsIP(IP)

            If ret = False Then
                Console.WriteLine("Please enter the correct IP")
            Else
                quitIP = True
                Thread.Sleep(100)
            End If
        End While

        hHS = HSDAQNet.Sys.HS_Device_Create(IP)
        Console.WriteLine("Module Name= " & HSDAQNet.Sys.HS_GetModelName(hHS).ToString())
        Console.WriteLine("HSDAQ Ver= " & HSDAQNet.Sys.GetSDKVersion().ToString())
        Console.WriteLine("HSDAQNet Ver= " & HSDAQNet.Sys.GetHSDAQNetVersion().ToString())
        Console.WriteLine("Firmware Ver= " & HSDAQNet.Sys.GetFirmwareVersion(hHS).ToString())
        ret = HSDAQNet.HSIO.HS_SetAIScanParam(hHS, ChCnt, Gain, TrigMode, sampleRate, targetCnt, DataTransMethod, AutoRun)
        HSDAQNet.HSIO.HS_GetAIScanParam(hHS, ChCnt, Gain, TrigMode, sampleRate, targetCnt, DataTransMethod, AutoRun)
        Console.WriteLine("Ch=" & ChCnt & ",Gain=" & Gain & ",TrigMode=" & TrigMode & ",sampleRate=" & sampleRate & ",targetCnt=" & targetCnt)
        'For details, please refer to the API manual
        'AI CH input Range : 1 ~ 4
        'Gain Range        : 0
        'Mode Range        : 0
        'Sample rate       : 
        '  ch=1    : 12.8k/16k/32k/64k/128k Hz
        '  ch=2    : 12.8k/16k/32k/64k Hz
        '  ch=3/4  : 12.8k/16k/32k Hz
        'targetcnt         : 0 (continue mode)
        'filetype          : 0(bin)、1(txt)、3(TDMS float)、4(TDMS Hex)
        'fileinterval      : min


        If Not ret Then
            Console.WriteLine("Error code1 0x" & HSDAQNet.ErrHandling.GetLastError().ToString("x8"))
        Else
            ret = HSDAQNet.DATALOG.HS_StartLogger(hHS, path, sfileinterval, sfiletype)

            If ret = False Then
                Console.WriteLine("Error code2 0x" & HSDAQNet.ErrHandling.GetLastError().ToString("x8"))
            End If

            While quit = False
                ret = HSDAQNet.HSIO.HS_GetTotalSamplingStatus(hHS, ulleng, triggerStatus)

                If ret = False Then
                    Console.WriteLine("Error code3 0x" & HSDAQNet.ErrHandling.GetLastError().ToString("x8"))
                Else

                    Console.Write(ulleng & vbCr)

                    If ulleng > 0 Then
                        If Console.KeyAvailable Then
                            If Console.ReadKey(True).Key = ConsoleKey.Q Then
                                Console.WriteLine(vbCrLf & "AP total read = " & ulleng & vbCrLf)
                                Exit While
                            End If
                        End If
                    End If
                End If
            End While

            HSDAQNet.DATALOG.HS_StopLogger(hHS)
            Thread.Sleep(10)
            HSDAQNet.Sys.HS_Device_Release(hHS)
        End If

        Dim gchCnt As Short = 0
        Dim guseGain As Short = 0
        Dim gextriggMode As Short = 0
        Dim gsampleRate As Integer = 0
        Dim gDataTransMethod As Short = 0
        Dim gSyncMode As Short = 0
        Console.WriteLine("Waiting for search File .....")
        Dim ind As Integer = HSDAQNet.DATALOG.HS_GetAllLogFiles(path, sfiletype)

        If ind > 0 Then

            For i As Integer = 0 To ind - 1
                Dim hlf As IntPtr = HSDAQNet.DATALOG.HS_LogFile_Open_byIndex(i, path)
                Console.WriteLine(vbCrLf & i & " ==> " & path)
                HSDAQNet.DATALOG.HS_GetLogFile_AIScanConfigInfo(hlf, gchCnt, guseGain, gextriggMode, gsampleRate, gDataTransMethod, gSyncMode)
                Console.WriteLine("Ch= " & gchCnt & "," & "Gain= " & guseGain & "," & "TriggMode= " & gextriggMode & "," & "SampleRate= " & gsampleRate & "," & "DataTransMethod= " & gDataTransMethod)
                Dim gainVal As UShort = 0
                Dim offsetVal As Short = 0
                Dim filesize As UInt32 = 0
                Dim filetype As Integer = 0
                Dim fileversion As Integer = 0
                Dim samplecount As UInt32 = 0
                Dim DataTime As String = ""
                Dim StartTime As String = ""
                Dim ModuleName As String = ""

                HSDAQNet.DATALOG.HS_GetLogFileInfo(hlf, ModuleName, filesize, filetype, fileversion)
                Console.WriteLine("Filesize= " & filesize & ",Filetype= " & filetype)
                HSDAQNet.DATALOG.HS_GetLogFile_AIScanSampleInfo(hlf, samplecount, DataTime, StartTime)
                Console.WriteLine("Samplecount= " & samplecount & ",DataTime= " & DataTime & ",StartTime= " & StartTime)
                Dim fdataBuffer As Single() = New Single(samplecount) {}
                HSDAQNet.DATALOG.HS_GetLogFile_AIData(hlf, 0, samplecount, fdataBuffer)
                Dim a As Integer = 0
                

                While a < 40
                    Console.WriteLine(fdataBuffer(a).ToString() & "," & fdataBuffer(a + 1).ToString() & "," & fdataBuffer(a + 2).ToString() & "," & fdataBuffer(a + 3).ToString())
                    a = a + 4
                End While
                HSDAQNet.DATALOG.HS_LogFile_Close(hlf)
            Next
        Else
            Console.WriteLine("No File!!")
        End If

        Console.WriteLine("Press 'Q' to quit program")


        While Console.ReadKey(True).Key <> ConsoleKey.Q
        End While
    End Sub

End Module
