﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Threading
Imports System.IO
Imports System.Text.RegularExpressions

Module Module1

    Public Function IsIP(ByVal ip As String) As Boolean
        Return Regex.IsMatch(ip, "^((2[0-4]\d|25[0-5]|[01]?\d\d?)\.){3}(2[0-4]\d|25[0-5]|[01]?\d\d?)$")
    End Function

    Sub Main()
        Dim IP As String = ""
        Dim ret As Boolean = False
        Dim quitIP As Boolean = False
        Dim quit As Boolean = False
        Dim hHS As IntPtr
        Dim ChCnt As Short = 4
        Dim Gain As Short = 0
        Dim ulleng As UInteger = 0
        Dim BufferStatus As UShort = 0
        Dim TrigMode As Short = 6
        Dim targetCnt As UInt32 = 4000
        Dim sampleRate As Integer = 16000
        Dim DataTransMethod As Short = 0
        Dim AutoRun As Short = 0
        Dim path As String = Directory.GetCurrentDirectory()
        Dim sfiletype As Integer = 1
        Dim sfileinterval As Integer = 1

        While quitIP = False
            Console.WriteLine("Please Enter IP!!")
            IP = Console.ReadLine()
            ret = IsIP(IP)

            If ret = False Then
                Console.WriteLine("Please enter the correct IP")
            Else
                quitIP = True
                Thread.Sleep(100)
            End If
        End While

        hHS = HSDAQNet.Sys.HS_Device_Create(IP)
        Console.WriteLine("Module Name= " & HSDAQNet.Sys.HS_GetModelName(hHS).ToString())
        Console.WriteLine("HSDAQ Ver= " & HSDAQNet.Sys.GetSDKVersion().ToString())
        Console.WriteLine("HSDAQNet Ver= " & HSDAQNet.Sys.GetHSDAQNetVersion().ToString())
        Console.WriteLine("Firmware Ver= " & HSDAQNet.Sys.GetFirmwareVersion(hHS).ToString())
        ret = HSDAQNet.HSIO.HS_SetAIScanParam(hHS, ChCnt, Gain, TrigMode, sampleRate, targetCnt, DataTransMethod, AutoRun)
        HSDAQNet.HSIO.HS_GetAIScanParam(hHS, ChCnt, Gain, TrigMode, sampleRate, targetCnt, DataTransMethod, AutoRun)
        Console.WriteLine("Ch=" & ChCnt & ",Gain=" & Gain & ",TrigMode=" & TrigMode & ",sampleRate=" & sampleRate & ",targetCnt=" & targetCnt)
        'For details, please refer to the API manual
        'AI CH input Range : 1 ~ 4
        'Gain Range        : 0
        'Mode Range        : 0 、 6
        'Sample rate       : 
        '  ch=1    : 12.8k/16k/32k/64k/128k Hz
        '  ch=2    : 12.8k/16k/32k/64k Hz
        '  ch=3/4  : 12.8k/16k/32k Hz
        'targetcnt         : 0 (continue mode)
        'AI trigger mode   : 0 ~ 3
        '   0:  Above
        '   1:  Below
        '   2:  Out-Range
        '   3:  In-Range

        Dim AImode As Integer = 2
        Dim left_cnt As UInt32 = 0
        Dim right_cnt As UInt32 = 4000
        Dim AI_EN As Byte() = New Byte(3) {CByte(1), CByte(1), CByte(1), CByte(1)} '1: enable , 0: disable
        Dim HI_level As Single() = New Single(3) {2, 2, 2, 2}
        Dim Low_level As Single() = New Single(3) {CSng(1.5), CSng(1.5), CSng(1.5), CSng(1.5)}
        Dim fdataBuffer As Single() = New Single(targetCnt) {}
        'Set the analog trigger range, as long as any channel condition is met, the data will be returned 
        'ret = HSDAQNet.HSIO.HS_SetAIAnalogTriggerParam(hHS, AImode, AI_EN, HI_level, Low_level, ch, left_cnt, right_cnt, 0);
        ret = HSDAQNet.HSIO.HS_SetAIAnalogTriggerParam(hHS, AImode, AI_EN, HI_level, Low_level, ChCnt, left_cnt, right_cnt, 0)

        If Not ret Then
            Console.WriteLine("Error code1 0x" & HSDAQNet.ErrHandling.GetLastError().ToString("x8"))
        Else
            ret = HSDAQNet.HSIO.HS_StartAIScan(hHS)

            If ret = False Then
                Console.WriteLine("Error code2 0x" & HSDAQNet.ErrHandling.GetLastError().ToString("x8"))
            End If

            While quit = False
                ret = HSDAQNet.HSIO.HS_GetAIBufferStatus(hHS, BufferStatus, ulleng)

                If ret = False Then
                    Console.WriteLine("Error code3 0x" & HSDAQNet.ErrHandling.GetLastError().ToString("x8"))
                Else

                    If ((ulleng >= targetCnt)) Then
                        HSDAQNet.HSIO.HS_GetAIBuffer(hHS, fdataBuffer, targetCnt)
                        Console.WriteLine(vbCrLf & "AP total read = " & ulleng.ToString() & vbCrLf)
                        Exit While
                    End If
                End If
            End While

            For i As Integer = 0 To 400 - 1
                If i Mod ChCnt = ChCnt - 1 Then
                    Console.Write(fdataBuffer(i).ToString() & vbCrLf)
                Else
                    Console.Write(fdataBuffer(i).ToString() & ",")
                End If
            Next

            HSDAQNet.HSIO.HS_StopAIScan(hHS)
            Thread.Sleep(10)
            HSDAQNet.Sys.HS_Device_Release(hHS)
        End If

        Console.WriteLine("Press 'Q' to quit program")


        While Console.ReadKey(True).Key <> ConsoleKey.Q
        End While
    End Sub

End Module
